Cambrionix connect
Developers
Hardware API

Hubs

Add, remove and list Hubs in a given organization.

Get Computer Hubs

GET

/hardware/v1/computers/{computerId}/hubs

Get hubs for a given computer.

Requires a bearer access token for this API with the Organization.Hub.Read permission. See Authentication.

Parameters

computerIdstringpathrequired

The unique identifier for a computer

filterstringquery

Returns only the items that match, written as (path::operator::value), such as (name::co::Lab). Operators are eq, co, sw, ew, gt and pr, and the case-insensitive ieq, ico, isw and iew. Combine conditions as ((a)::and::(b)) or ((a)::or::(b)).

sortstringquery

Orders the items, written as (path::asc) or (path::desc). Combine orders as ((a)::and::(b)).

limitintegerquery

The maximum number of items to return.

tokenstringquery

Returns the next page: the _metadata.continuationToken of the previous response.

Responses

200

Response schema with result and metadata

object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultOrganizationHub[]required
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X GET "https://connect.cambrionix.com/api/hardware/v1/computers/{computerId}/hubs" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN"

Create a new hub

POST

/hardware/v1/hub

Create a new hub for an organization, with the given serial number and product type.

Requires a bearer access token for this API with the Organization.Hub.Write permission. See Authentication.

Request body

object
additionalHardwareobject[]

The additional hardware associated with the hub

bootloaderobject

The bootloader information for the hub

firmwareobject

The firmware information for the hub

hostobject

The host information for this hub

namestring

The name of the hub

noteobject

A note about this hub

parentHubstring

The parent hub of this hub.

productobject

The Hub Product ID that is associated with this hub

serialNumberstringrequired
serialPortobject

The serial port information for the hub

serviceobject

The Hub API Service associated with this hub

settingsmap of any

The settings for the hub

idstring

The unique identifier for the hub. This is the hub serial number.

metadatamap of any

Additional metadata for this hub

portsmap of object

The ports on this hub and any additional metadata for each port

Responses

200

Response schema with result and metadata

object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultobjectrequired
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X POST "https://connect.cambrionix.com/api/hardware/v1/hub" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  -d '{
  "additionalHardware": [
    {
      "bootloader": {
        "version": "string"
      },
      "description": "string",
      "firmware": {
        "type": "string",
        "version": "string"
      },
      "group": "string",
      "manufacturer": "string",
      "serialNumber": "string"
    }
  ],
  "bootloader": {
    "version": "string"
  },
  "firmware": {
    "type": "un",
    "version": "string"
  },
  "host": {
    "connection": {
      "status": "connected",
      "updated": 0,
      "speed": {},
      "type": "usb",
      "version": "string",
      "error": {
        "errorId": "string"
      }
    }
  },
  "name": "string",
  "note": {
    "content": "string"
  },
  "parentHub": "string",
  "product": {
    "id": "string"
  },
  "serialNumber": "string",
  "serialPort": {
    "connection": "string",
    "error": {
      "code": "serial_in_use",
      "errorId": "string",
      "message": "string"
    },
    "location": {
      "computerId": "00000000-0000-0000-0000-000000000000",
      "locationId": 0
    },
    "status": "connected"
  },
  "service": {
    "address": {
      "hostName": "string",
      "port": 0
    },
    "computer": {
      "id": "00000000-0000-0000-0000-000000000000",
      "name": "string"
    },
    "id": "string"
  },
  "id": "string"
}'

Get Hubs with Firmware Updates Available

GET

/hardware/v1/hub/firmware/check

Get all hubs with firmware updates available.

Requires a bearer access token for this API with the Organization.Hub.Read permission. See Authentication.

Responses

200
object
_metadataobjectrequired
resultobject[]required
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X GET "https://connect.cambrionix.com/api/hardware/v1/hub/firmware/check" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN"

List Hubs

GET

/hardware/v1/hubs

List the organization's hubs with product, firmware version, connection status, settings and host computer.

Requires a bearer access token for this API with the Organization.Hub.Read permission. See Authentication.

Parameters

filterstringquery

Returns only the items that match, written as (path::operator::value), such as (name::co::Lab). Operators are eq, co, sw, ew, gt and pr, and the case-insensitive ieq, ico, isw and iew. Combine conditions as ((a)::and::(b)) or ((a)::or::(b)).

sortstringquery

Orders the items, written as (path::asc) or (path::desc). Combine orders as ((a)::and::(b)).

limitintegerquery

The maximum number of items to return.

tokenstringquery

Returns the next page: the _metadata.continuationToken of the previous response.

Responses

200

Response schema with result and metadata

object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultOrganizationHub[]required
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X GET "https://connect.cambrionix.com/api/hardware/v1/hubs" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN"

Get a Hub

GET

/hardware/v1/hubs/{serialNumber}

Get one hub (product, firmware, connection status, settings, host computer) by serial number.

Requires a bearer access token for this API with the Organization.Hub.Read permission. See Authentication.

Parameters

serialNumberstringpathrequired

Path parameter

Responses

200

Response schema with result and metadata

object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultobjectrequired
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X GET "https://connect.cambrionix.com/api/hardware/v1/hubs/{serialNumber}" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN"

Patch a Hub

PATCH

/hardware/v1/hubs/{serialNumber}

Patch a Hub.

Requires a bearer access token for this API with the Organization.Hub.Write permission. See Authentication.

Parameters

serialNumberstringpathrequired

Path parameter

Request body

object
additionalHardwareobject[]

The additional hardware associated with the hub

bootloaderobject

The bootloader information for the hub

firmwareobject

The firmware information for the hub

hostobject

The host information for this hub

namestring

The name of the hub

noteobject

A note about this hub

parentHubstring

The parent hub of this hub.

productobject

The Hub Product ID that is associated with this hub

serialNumberstring
serialPortobject

The serial port information for the hub

serviceobject

The Hub API Service associated with this hub

settingsmap of any

The settings for the hub

metadatamap of any

Additional metadata for this hub

portsmap of object

The ports on this hub and any additional metadata for each port

Responses

200

Response schema with result and metadata

object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultobjectrequired
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X PATCH "https://connect.cambrionix.com/api/hardware/v1/hubs/{serialNumber}" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN" \
  -H "Content-Type: application/json" \
  -d '{
  "additionalHardware": [
    {
      "bootloader": {
        "version": "string"
      },
      "description": "string",
      "firmware": {
        "type": "string",
        "version": "string"
      },
      "group": "string",
      "manufacturer": "string",
      "serialNumber": "string"
    }
  ],
  "bootloader": {
    "version": "string"
  },
  "firmware": {
    "type": "un",
    "version": "string"
  },
  "host": {
    "connection": {
      "status": "connected",
      "updated": 0,
      "speed": {},
      "type": "usb",
      "version": "string",
      "error": {
        "errorId": "string"
      }
    }
  },
  "name": "string",
  "note": {
    "content": "string"
  },
  "parentHub": "string",
  "product": {
    "id": "string"
  },
  "serialNumber": "string",
  "serialPort": {
    "connection": "string",
    "error": {
      "code": "serial_in_use",
      "errorId": "string",
      "message": "string"
    },
    "location": {
      "computerId": "00000000-0000-0000-0000-000000000000",
      "locationId": 0
    },
    "status": "connected"
  },
  "service": {
    "address": {
      "hostName": "string",
      "port": 0
    },
    "computer": {
      "id": "00000000-0000-0000-0000-000000000000",
      "name": "string"
    },
    "id": "string"
  }
}'

Delete a Hub

DELETE

/hardware/v1/hubs/{serialNumber}

Delete a Hub.

Requires a bearer access token for this API with the Organization.Hub.Delete permission. See Authentication.

Parameters

serialNumberstringpathrequired

Path parameter

Responses

200
object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultobjectrequired
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X DELETE "https://connect.cambrionix.com/api/hardware/v1/hubs/{serialNumber}" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN"

Get Hub Unlock Status

GET

/hardware/v1/hubs/{serialNumber}/unlock-status

Endpoint to check if a hub can be unlocked.

Requires a bearer access token for this API with the Organization.Hub.Read permission. See Authentication.

Parameters

serialNumberstringpathrequired

Path parameter

Responses

200
object
_metadataobject

Metadata for paginated responses. This includes total count, limit, and continuation token.

resultobjectrequired
401

Unauthorized

object
codeintegerrequired

One of: 401

messagestringrequired

One of: "Unauthorized"

detailstringrequired
403

Forbidden: the token is valid but does not allow this request

object
codeintegerrequired
messagestringrequired
detailstringrequired
default

Error

object
codeintegerrequired

One of: 500

messagestringrequired

One of: "Unauthorized"

detailstringrequired

Try it

curl -X GET "https://connect.cambrionix.com/api/hardware/v1/hubs/{serialNumber}/unlock-status" \
  -H "Authorization: Bearer $CONNECT_ACCESS_TOKEN"